;Revision Status:
;
;Version:  1.0
;Date:  Start
;Size/Cycles:  1586/6392
;Internal Release.
;
;Version:  1.0a
;Date:  Oct. 4, 2000
;Size/Cycles:  1553/6369 (-33/-23)
;Optimized.
;
;Version:  1.0b
;Date:  Oct. 5, 2000
;Size/Cycles:  1513/6279 (-40/-90)
;More Optimizing.
;Public Release.
;
;Version:  1.1
;Date:  Oct. 6, 2000
;Size/Cycles:  1889/8257 (+376/+1978)
;Changed Credits/Fight System to W/L/% System.
;Added Status checking features.
;Slight Altering to Interface.
;Internet Release.
;
;Version:  1.2
;Date:  Oct. 7, 2000
;Size/Cycles:  1796/7765 (-93/-492)
;More Optimizing.
;Edited the Status Checker to include Stats.
;Fixed "God's Stats" bug.
;Fixed "OverFlow" bug.


#include "ti86asm.inc"

.org _asm_exec_ram			;<-	Heh...  .org asm...

	nop						;	This routine is for shell identification...
	jp ProgStart			;
	.dw 0					;
	.dw ShellTitle			;

ShellTitle:
	.db "Custom Cock-Fighter",0

ProgStart:

;The first thing we want to do is set the flags up so the screen won't scroll,
;the graph data is NOT saved in the textshadow, and the run indicator is off.
;Thanks to YAS documentation, I can now remove the menus from the bottom, fixing
;a bug in earlier versions.
	
	di
;	set indicOnly,(iy+indicflags)
	res plotloc,(iy+plotflags)
	res appTextSave,(iy+appflags)
	res indicRun,(iy+indicflags)
	call _flushallmenus

;This will display the title screen and reset your current stats.

	call _clrScrn			;	Display the title
	ld hl,3*256+22			;
	ld (_penCol),hl			;
	ld hl,ShellTitle		;
	call _vputs				;

	ld hl,29*256+1			;	Display my name
	ld (_penCol),hl			;	PLEASE DO NOT ALTER THIS CODE.
	ld hl,author			;	Thank you.
	call _vputs				;

	ld hl,36*256+1			;	Display version (Customizable)
	ld (_penCol),hl			;	
	ld hl,Version			;	
	call _vputs

	ld hl,43*256+1			;	Display compiler message (Customizable)
	ld (_penCol),hl			;	
	ld hl,compiler			;	
	call _vputs

	ld hl,50*256+1			;	Display compile date
	ld (_penCol),hl			;	(Comment this out if you are not
	ld hl,date				;	using ASM Studio 86)
	call _vputs

	ld hl,57*256+1			;	Display compile time
	ld (_penCol),hl			;	(Comment this out if you are not
	ld hl,time				;	using ASM Studio 86)
	call _vputs				;
	
	call _getkey
	jr GetFighters			;<-	I do this to avoid a Div By Zero error.

	
Status:

;This routine calculates the % each time you win/lose a fight
;and stores in (Percent).  Also checks to see if either the wins,
;losses, or fighter wins/losses are going to overflow and clears
;them.

	ld hl,(Wins)			;	First take (Wins)...
	call _setXXXXop2		;	Load into Op2...
	call _op2toop1			;	Move that to Op1...

	ld hl,(Wins)			;	Add (Wins) and (Losses) together...
	ld de,(Losses)			;
	add hl,de				;
	call _setXXXXop2		;	Load into Op2...
	call _FPDIV				;	Op1 / Op2 = Op1...
	call _inco1exp			;	Op1 * 10...
	call _inco1exp			;	Op1 * 10...
	call _convop1			;	Convert Intiger of Op1 to ADE...
	ex de,hl				;	Swap HL and DE...
	ld (Percent),hl			;	Load into (Percent)

CheckSum1:

	ld hl,(Wins)
	ld a,l
	cp $FF
	jr z,CheckSum1a

CheckSum2:

	ld hl,(Losses)
	ld a,l
	cp $FF
	jr z,CheckSum2a

CheckSum3:

	ld a,(Fighter1)
	call FStatOffset
	ld a,(hl)
	cp $FF
	jp z,ClearFStat
	inc hl
	ld a,(hl)
	cp $FF
	jp z,ClearFStat

	ld a,(Fighter2)
	call FStatOffset
	ld a,(hl)
	cp $FF
	jp z,ClearFStat
	inc hl
	ld a,(hl)
	cp $FF
	jp z,ClearFStat
	jp GetFighters


CheckSum1a:
	ld a,h
	cp $FF
	jp z,ClearStat
	jr CheckSum2

CheckSum2a:
	ld a,h
	cp $FF
	jp z,ClearStat
	jr CheckSum3

GetFighters:

;This routine picks two random fighters and stores their offsets into
;either (Fighter1) or (Fighter2).

	call Random1			;<-	Stores a random number between 0 and (Number)-1
							;	into A...
	ld (Fighter1),a			;	...Then into (Fighter1)

	call Random1			;<-	Stores a random number between 0 and (Number)-1
							;	into A...
	ld (Fighter2),a			;	...Then into (Fighter2)

	ld b,a					;	Load (Fighter2) into B
	ld a,(Fighter1)			;	Load (Fighter1) into A
	cp b					;	Compair the two
	jr z,GetFighters		;	If they are the same fighter, pick two new ones.


Status3:

;Now the program draws the W/L/% record on the top and displays
;the fighter's names and menu.

	call _clrLCD			;	Clear the Screen
	call _homeup			;	Display W:
	ld hl,SW				;
	call _puts				;

	ld a,0					;	Calculate and display (Wins)
	ld hl,(Wins)			;
	call _dispAHL			;

	ld hl,$0001				;	Display L:
	ld (_curRow),hl			;
	ld hl,SL				;
	call _puts				;

	ld a,0					;	Calculate and display (Losses)
	ld hl,(Losses)			;	
	call _dispAHL			;	

	ld hl,$0002				;	Display %:
	ld (_curRow),hl			;
	ld hl,SP				;
	call _puts				;

	ld a,0					;	Calculate and display (Percent)
	ld hl,(Percent)			;	
	call _dispAHL			;

	ld hl,$0004				;	I owe a big one to David Phillips, head
	ld (_curRow),hl			;	of the 86ASM section over at ACZ.org.
	ld hl,One				;	I couldn't get my homemade routine to
	call _puts				;	display any of the strings correctly
							;	because I was treating ASM like a high-
							;	level opperating language.  He showed
							;	me how to do what I was trying to do in
	ld a,(Fighter1)			;	ASM, and he wrote the _dispString routine
	ld d,a					;
	call _dispString		;<-	:)
							;
	ld hl,$0905				;
	ld (_curRow),hl			;
	ld hl,VS				;
	call _puts				;
							;
	ld hl,$0006				;
	ld (_curRow),hl			;
	ld hl,Two				;
	call _puts				;
							;
	ld a,(Fighter2)			;
	ld d,a					;
	call _dispString		;<-	:)

	ld hl,57*256+6			;	Display the F-key menu
	ld (_penCol),hl			;
	ld hl,Menu1				;
	call _vputs				;
							;
	ld hl,57*256+35			;
	ld (_penCol),hl			;
	ld hl,Menu2				;
	call _vputs				;
							;
	ld hl,57*256+57			;
	ld (_penCol),hl			;
	ld hl,Menu3				;
	call _vputs				;
							;
	ld hl,57*256+84			;
	ld (_penCol),hl			;
	ld hl,Menu4				;
	call _vputs				;
							;
	ld hl,57*256+110		;
	ld (_penCol),hl			;
	ld hl,Menu5				;
	call _vputs				;

GetBet:

	call _getkey			;	A simple loop to check if you press F1-5 or Exit.
	cp kF1					;<-	F1 = Bet on fighter1
	jp z,Choose1			;
	cp kF2					;<- F2 = Bet on fighter2
	jp z,Choose2			;
	cp kF3					;<- F3 = Check Status of Fighters
	jp z,CheckStat			;
	cp kF4					;<- F4 = Clear Stats
	jp z,ClearStat			;
	cp kF5					;<- F5 = Exit
	jp z,Exit				;
	cp kExit				;<- Exit = Exit
	jp z,Exit				;
	jp nz,GetBet			;	Everything else = Restart


Choose1:

;These two routines just load your choice (0 or 1) into a variable
;just so I can check if you won later on.

	ld a,0					;	You get the idea...
	ld (Choice),a			;
	jr BigLoopStart			;

Choose2:

	ld a,1					;
	ld (Choice),a			;


BigLoopStart:

;This is the begining of the actual fighting section.
;Everything from here on out is automatic.

	call _ReadyDelay		;<-	Waits, then displays the fighting board

	ld a,(Fighter1)			;	Loads (Fighter1) into A
	call StatOffset			;<-	Calculates the Health (+0) Offset for Fighter A

	ld a,(hl)				;	Loads +0 (Health Stat) into (Health1)
	ld (Health1),a			;

	ld hl,$0801				;	Displays (Health1)
	ld (_curRow),hl			;
	call _dispA				;<-	Display value in A

	ld a,(Fighter2)			;	Loads (Fighter2) into A
	call StatOffset			;<-	Calculates the Health (+0) Offset for Fighter A

	ld a,(hl)				;	Loads +0 (Health Stat) into (Health2)
	ld (Health2),a			;

	ld hl,$0805				;	Displays (Health2)
	ld (_curRow),hl			;
	call _dispA				;<-	Display value in A

BigLoop:

;Now Healths have been displayed, time for some kickin' ass!

	ld hl,$0801				;	Display Fighter 1's Health
	ld (_curRow),hl			;
	ld a,(Health1)			;
	call _dispA				;

	call TLoopShort			;<-	A simple loop that waits a bit

;I'm going to wait, then clear out the actions...

	ld hl,$0806
	ld (_curRow),hl
	ld hl,Blank
	call _puts

;Check to see if Fighter1's dead:

	ld a,(Health1)
	or a
	jp z,Check1

;Fighter1's Turn:

	call Random2			;	Phil's attempt to load a random intiger from

	ld a,(Cache)
	cp 1
	jp z,ActionSpec1

	ld a,(Cache)
	cp 6
	jp z,ActionPunch1
	jp m,ActionPunch1

	jp ActionKick1

;Fighter1's Special Move:

ActionSpec1:

	ld hl,$0802
	ld (_curRow),hl

	ld a,(Fighter1)			;	Display the Special Move using
	ld d,a					;	David's routine.  Thanks again!
	call _dispSpec			;<-	:)

	ld a,(Fighter1)			;	Calculates Special Offsets for fighter1...
	call StatOffset
	inc hl					;<- 3+ for Special Stat (#4)
	inc hl
	inc hl
							;
	ld a,(hl)
	push af					;	Special Attack for Fighter1 is now in the Stack!

	ld a,(Fighter2)
	call _DefCheck			;<- Change the Def to a random intiger bet 0 and Def Stat.

	pop af					;	a = Special attack for fighter1 
	dec b					;<-	Defense minus 2 for Special.
	dec b					;<-
	sub b
	call m,ZeroToA			;	If Def is greater than Off, recalc.

;Now a = amount to take away from other fighter's health...

	ld b,a
	ld a,(Health2)
	sub b
	call m,ZeroToA
	ld (Health2),a

;Done, Continuing with Player 2's turn...

	jp BigLoop2

ActionPunch1:

	ld hl,$0802
	ld (_curRow),hl
	ld hl,Punch
	call _puts

	ld a,(Fighter1)			;	Calculates Special Offsets for fighter1...
	call StatOffset
	inc hl					;<- 3+ for Special Stat (#4)
							;
	ld a,(hl)	
	sra a					;	div by 2

	push af					;	Attack for Fighter1 is now in the Stack!

	ld a,(Fighter2)
	call _DefCheck			;<- Change the Def to a random intiger bet 0 and Def Stat.

	pop af					;	a = Special attack for fighter1 
	sub b
	call m,ZeroToA			;	If Def is greater than Off, recalc.

;Now a = amount to take away from other fighter's health...

	ld b,a
	ld a,(Health2)
	sub b
	call m,ZeroToA
	ld (Health2),a

;Done, Continuing with Player 2's turn...

	jp BigLoop2

ActionKick1:

	ld hl,$0802
	ld (_curRow),hl
	ld hl,Kick
	call _puts

	ld a,(Fighter1)			;	Calculates Attack Offsets for fighter1...
	call StatOffset
	inc hl					;<- 3+ for Special Stat (#4)
							;
	ld a,(hl)
	push af					;	Attack for Fighter1 is now in the Stack!

	ld a,(Fighter2)
	call _DefCheck			;<- Change the Def to a random intiger bet 0 and Def Stat.

	pop af					;	a = Special attack for fighter1 
	sub b
	call m,ZeroToA			;	If Def is greater than Off, recalc.

;Now a = amount to take away from other fighter's health...

	ld b,a
	ld a,(Health2)
	sub b
	call m,ZeroToA
	ld (Health2),a

;Done, Continuing with Player 2's turn...

BigLoop2:

;Now Display Fighter 2's health...

	ld hl,$0805
	ld (_curRow),hl
	ld a,(Health2)
	call _dispA

	call TLoopShort

;I'm going to wait, then clear out the actions...

	ld hl,$0802
	ld (_curRow),hl
	ld hl,Blank
	call _puts

;Check to see if Fighter2's dead:

	ld a,(Health2)
	or a
	jp z,Check2

;Fighter2's Turn:

	call Random2

	ld a,(Cache)
	cp 1
	jp z,ActionSpec2

	ld a,(Cache)
	cp 6
	jp z,ActionPunch2
	jp m,ActionPunch2

	jp ActionKick2

ActionSpec2:

	ld hl,$0806
	ld (_curRow),hl

	ld a,(Fighter2)			;	Display the Special Move using
	ld d,a					;	David's routine.  Thanks again!
	call _dispSpec			;<-	:)

	ld a,(Fighter2)			;	Calculates Special Offsets for fighter1...
	call StatOffset
	inc hl					;<- 3+ for Special Stat (#4)
	inc hl
	inc hl
							;
	ld a,(hl)
	push af					;	Special Attack for Fighter1 is now in the Stack!

	ld a,(Fighter1)
	call _DefCheck			;<- Change the Def to a random intiger bet 0 and Def Stat.

	pop af					;	a = Special attack for fighter1 
	dec b					;<-	Defense minus 2 for Special move.
	dec b					;<-	
	sub b
	call m,ZeroToA			;	If Def is greater than Off, recalc.

;Now a = amount to take away from other fighter's health...

	ld b,a
	ld a,(Health1)
	sub b
	call m,ZeroToA
	ld (Health1),a

;Done, Continuing with Player 2's turn...

	jp BigLoop

ActionPunch2:

	ld hl,$0806
	ld (_curRow),hl
	ld hl,Punch
	call _puts

	ld a,(Fighter2)			;	Calculates Special Offsets for fighter1...
	call StatOffset
	inc hl					;<- 3+ for Special Stat (#4)
							;
	ld a,(hl)
	sra a					;	div by 2

	push af					;	Attack for Fighter1 is now in the Stack!

	ld a,(Fighter1)
	call _DefCheck			;<- Change the Def to a random intiger bet 0 and Def Stat.

	pop af					;	a = Special attack for fighter1 
	sub b
	call m,ZeroToA			;	If Def is greater than Off, recalc.

;Now a = amount to take away from other fighter's health...

	ld b,a
	ld a,(Health1)
	sub b
	call m,ZeroToA
	ld (Health1),a

;Done, Continuing with Player 2's turn...

	jp BigLoop

ActionKick2:

	ld hl,$0806
	ld (_curRow),hl
	ld hl,Kick
	call _puts

	ld a,(Fighter2)			;	Calculates Special Offsets for fighter1...
	call StatOffset
	inc hl					;<- 3+ for Special Stat (#4)
							;
	ld a,(hl)

	push af					;	Attack for Fighter1 is now in the Stack!

	ld a,(Fighter1)
	call _DefCheck			;<- Change the Def to a random intiger bet 0 and Def Stat.

	pop af					;	a = Special attack for fighter1 
	sub b
	call m,ZeroToA			;	If Def is greater than Off, recalc.

;Now a = amount to take away from other fighter's health...

	ld b,a
	ld a,(Health1)
	sub b
	call m,ZeroToA
	ld (Health1),a

;Done, Continuing with Player 2's turn...

	jp BigLoop


Check1:

	ld a,(Fighter1)			;	Calculates Special Offsets for fighter1...
	call FStatOffset
	inc hl
	ld a,(hl)
	inc a
	ld (hl),a

	ld a,(Fighter2)			;	Calculates Special Offsets for fighter1...
	call FStatOffset
	ld a,(hl)
	inc a
	ld (hl),a

	ld a,(Choice)
	or a
	jp z,Lose
	jp nz,Win

Check2:

	ld a,(Fighter2)			;	Calculates Special Offsets for fighter1...
	call FStatOffset
	inc hl
	ld a,(hl)
	inc a
	ld (hl),a

	ld a,(Fighter1)			;	Calculates Special Offsets for fighter1...
	call FStatOffset
	ld a,(hl)
	inc a
	ld (hl),a

	ld a,(Choice)
	or a
	jp z,Win
	jp nz,Lose

Win:

	ld hl,(Wins)
	inc hl
	ld (Wins),hl

	ld hl,$0603
	ld (_curRow),hl
	ld hl,Winner
	call _puts
	call TLoopShort

	jp Status

Lose:

	ld hl,(Losses)
	inc hl
	ld (Losses),hl

	ld hl,$0603
	ld (_curRow),hl
	ld hl,Loser
	call _puts
	call TLoopShort

	jp Status


Exit:						;	This is the final routine...  exits out afterward.
	
	call _clrLCD
	ld hl,$0000
	ld (_curRow),hl
	ld hl,SP
	call _puts

	ld a,0
	ld hl,(Percent)
	call _dispAHL

	call _newline
	ld hl,ExitT
	call _puts

	set plotloc,(iy+plotflags)
	set appTextSave,(iy+appflags)
	set indicRun,(iy+indicflags)
;	res indicOnly,(iy+indicflags)

	ei
	ret						;<-	We're done!  Woo Hoo!

;-----------------------------------------------------------Strings

;Cocks.inc is the include file that contains all the custom CockFighters.

#include cocks.inc

SH:
	.db "H:",0
SO:
	.db "O:",0
SD:
	.db "D:",0
SS:
	.db "S:",0
Winner:
	.db "Winner!",0
Loser:
	.db "Loser!",0
ExitT:
	.db "You Suck",0
Cache:
	.db 0
Choice:
	.db 0
Offset:
	.dw 0
Blank:
	.db "             ",0
Ready:
	.db "Ready...",0
Fight2:
	.db "Fight!",0

Fighter1:
	.db 0
Fighter2:
	.db 0
One:
	.db "1: ",0
Two:
	.db "2: ",0
Menu1:
	.db "1",0
Menu2:
	.db "2",0
Menu3:
	.db "Stats",0
Menu4:
	.db "Clear",0
Menu5:
	.db "Exit",0

SW:
	.db "W: ",0
SL:
	.db "L: ",0
SP:
	.db "%: ",0
Wins:
	.dw 0
Losses:
	.dw 0
Percent:
	.dw 0
SHealth:
	.db "Health:",0
Health1:
	.db 0
Health2:
	.db 0
Action:
	.db "Action:",0
Punch:
	.db "Punch",0
Kick:
	.db "Kick",0
VS:
	.db "VS",0


date:						;__DATE__ is a macro, along with __TIME__...
	.db __DATE__,0
time:						;...used in 86 ASM Studio only.
	.db __TIME__,0
author:
	.db "By Phillip Killewald",0

;-----------------------------------------Things I shouldn't worry about

_dispString:
	ld hl,Char
	call FindString
	call _puts
	ret
FindString:					;-- Points HL to string HL + D Zero-terminated strings --
	ld bc,$ffff
Loop:
	ld a,d
	or a
	ret z
	sub a
	cpir
	dec d
	jr Loop

_dispSpec:
	ld hl,Spec
	call FindString2
	call _puts
	ret
FindString2:					;-- Points HL to string HL + D Zero-terminated strings --
	ld bc,$ffff
Loop2:
	ld a,d
	or a
	ret z
	sub a
	cpir
	dec d
	jr Loop2


MakeField:

	call _clrLCD
	call _homeup

	ld a,(Fighter1)
	ld d,a
	call _dispString		;<-	:)
							;
	ld hl,$0001				;
	ld (_curRow),hl			;
	ld hl,SHealth			;
	call _puts				;

	ld hl,$0002				;
	ld (_curRow),hl			;
	ld hl,Action			;
	call _puts				;

	ld hl,$0004				;
	ld (_curRow),hl			;
							;
	ld a,(Fighter2)			;
	ld d,a					;
	call _dispString		;<-	:)

	ld hl,$0005				;
	ld (_curRow),hl			;
	ld hl,SHealth			;
	call _puts				;

	ld hl,$0006				;
	ld (_curRow),hl			;
	ld hl,Action			;
	call _puts				;

	ret

_ReadyDelay:

	call _clrLCD

	ld hl,5*256+3
	ld (_curRow),hl
	ld hl,Ready
	call _puts

	call TLoopShort

	call MakeField

	ld hl,6*256+3
	ld (_curRow),hl
	ld hl,Fight2
	call _puts

	call TLoopShort

	ld hl,6*256+3
	ld (_curRow),hl
	ld hl,Blank
	call _puts
	ret

TLoopShort:
	ei
	ld a,18
TLoopShort2:
	halt
	halt
	halt
	halt
	halt
	dec a
	or a
	jr nz,TLoopShort2
	di
	ret

_DefCheck:

	call StatOffset
	inc hl					;<- 2+ for Def Stat (#4)
	inc hl

	push hl

	call _random

	pop hl

	ld a,(hl)				;	
	call _setXXop2
	rst 28h
	call _convop1
	ld b,e
	ret

ZeroToA:
	ld a,0
	ret

Random1:

	call _random
	ld a,(Number)
	call _setXXop2

	rst 28h
	call _convop1

	ld a,e
	ret

Random2:

	call _random
	ld a,11					;	0 to 10 into a.  I couldn't think of an
	call _setXXop2			;	easier way to do it besides with OP commands.
	rst 28h					;<- This multiplies OP1 and OP2, stores answer in OP1
	call _convop1			;
	ld a,e					;<-	E fuckin' works!  Sweet!  (I thought it was L...)
	inc a					;
	ld (Cache),a			;	Basically, I just did (rand*11)+1
	ret

ClearStat:

	call _clrScrn
	ld hl,$0000
	ld (Wins),hl
	ld (Losses),hl
	ld (Percent),hl
	jp Status3

ClearFStat:

	ld a,$00
	ld hl,(Offset)
	ld (hl),a
	inc hl
	ld (hl),a
	jp Status3

CheckStat:

	call _clrScrn
	call _homeup

	ld a,(Fighter1)
	ld d,a
	call _dispString		;<-	:)

	ld hl,$0101
	ld (_curRow),hl

	ld a,(Fighter1)			;	Calculates Special Offsets for fighter1...
	call StatOffset

	call Displays

	ld hl,$0802
	ld (_curRow),hl

	ld a,(Fighter1)
	call FStatOffset

	call Displays2

	ld hl,$0004
	ld (_curRow),hl

	ld a,(Fighter2)
	ld d,a
	call _dispString		;<-	:)

	ld hl,$0105
	ld (_curRow),hl

	ld a,(Fighter2)			;	Calculates Special Offsets for fighter1...
	call StatOffset

	call Displays

	ld hl,$0806
	ld (_curRow),hl

	ld a,(Fighter2)
	call FStatOffset

	call Displays2

	call _getkey
	jp Status3

StatOffset:

;Points hl to address in memory that is at fighter A's Health (0 offset)

	or a
	jr z,GodStat
	ld h,a					;	
	ld l,4					;
	call _HtimesL			;
	ld de,Stat				;	load the address of Stat
	add hl,de				;	add the offset to the address
							;	now HL points to Special
	ld (Offset),hl
	ret

GodStat:
	ld hl,Stat
	ld (Offset),hl
	ret

FStatOffset:

;Points hl to address in memory that is at fighter A's Wins (0 offset)

	or a
	jr z,GodFStat
	ld h,a					;	
	ld l,2					;
	call _HtimesL			;
	ld de,FStat				;	load the address of Stat
	add hl,de				;	add the offset to the address
							;	now HL points to Special
	ld (Offset),hl
	ret

GodFStat:
	ld hl,FStat
	ld (Offset),hl
	ret

Displays:

	ld a,(hl)
	call _dispA

	ld a,$08
	ld (_curCol),a

	ld hl,(Offset)
	inc hl
	ld a,(hl)

	call _dispA

	ld a,15
	ld (_curCol),a

	ld hl,(Offset)
	inc hl
	inc hl
	ld a,(hl)

	call _dispA

	ld a,0
	ld (_curCol),a
	ld hl,SH
	call _puts

	ld a,7
	ld (_curCol),a
	ld hl,SO
	call _puts

	ld a,14
	ld (_curCol),a
	ld hl,SD
	call _puts

	call _newline

	ld a,1
	ld (_curCol),a

	ld hl,(Offset)
	inc hl
	inc hl
	inc hl
	ld a,(hl)

	call _dispA

	ld a,0
	ld (_curCol),a
	ld hl,SS
	call _puts

	ret

Displays2:

	ld a,(hl)
	call _dispA

	ld a,15
	ld (_curCol),a

	ld hl,(Offset)
	inc hl
	ld a,(hl)

	call _dispA

	ld a,7
	ld (_curCol),a
	ld hl,SW
	call _puts

	ld a,14
	ld (_curCol),a
	ld hl,SL
	call _puts

	ret

_dispA:
	ld h,0
	ld l,a
	ld a,0
	call _dispAHL
	ret


;----------------------------------Customizable...


.end
